# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS$
#----------------------------------------------------------------------
package provide Gdhe::models 1.0

# variable qui indique s'il faut dessiner les reperes
global armFrames

if ![info exists armFrames] {
    set armFrames false
}

#     Dessin conditionnel de repere
#     l: longueur des axes
#    x y z: translation / repere courant
#    r g b: couleur
#

proc armRepereCond {l x y z r g b} {
    
    global armFrames
    if {$armFrames} {
	pushMatrix
	translate $x $y $z
	color $r $g $b
	repere $l
	popMatrix
    }
}
###
### Bras Robotsoft
###
proc arm1 {a1 a2 a3 a4 a5 a6} {

    cullFace True
    pushMatrix
    object ArmBase {
	color 150 120 0
	cylinder 0. 0. 0. z .15 .255
    }
     # repere 
    armRepereCond 0.3 0 0 0 230 0 0 
    # corps 1
    rotate [expr $a1 + 0] 0 0 1
    object Arm1 {
	color 10 10 10
	cylinder 0. 0. .255 z .12 .05
	color 150 120 0
	box .0 .0 .305 .15 .09 .21
	color 10 10 10
	cylinder 0 .045 .415 y .12 0.04
    }
    translate 0 .075 .415
    rotate [expr $a2 - 90] 0 -1 0 
    # corps 2
    object Arm2 {
	color 150 120 0
	cylinder 0 0 -.265 y .14 .055
	cylinder 0 0 .3 y .14 .055
	box 0 .0276 -.265 .14 .057 .565
	color 10 10 10
	cylinder 0 .055 -.265 y .14 .1
	cylinder 0 .055 .3 y .14 .012
	box 0 .06 -.265 .14 .01 .565
    }
    translate 0 0 .3
    rotate [expr $a3 - 90 ] 0 -1 0
    # corps 3
    object Arm3 {
	color 10 10 10
	cylinder 0 -.03 0 y .12 .03
	color 150 120 0
	cylinder 0 -.12 0 y .13 .09
	color 10 10 10 
	cylinder 0 -.08 -.11 z 0.063 .47
    }
    translate 0 -.08 .36
    rotate [expr $a4 + 0] 0 0 1
    # corps 4
    object Arm4 {
	color 150 120 0
	box 0 0 0 .07 .07 .01
	box 0 0.03 0.005 .07 .01 .07
    }
    translate 0 -0.01 .04
    rotate [expr $a5 + 0] 0 -1 0
    # corps 5
    object Arm5 {
	color 10 10 10
	cylinder 0 -0.10 0 y .063 .13
	cylinder 0 0 0 z 0.063 .13
	translate 0 0 0.13
	cylinder 0 0 0 z 0.03 .015
	cylinder 0 0 0.015 z 0.063 .005
	color 255 255 255
	cylinder 0 0 0.02 z 0.063 .05
	color 10 10 10
	cylinder 0 0 0.07 z 0.063 .005
	cylinder 0 0 0.075 z 0.03 .015

    }
    # corps 6
    translate 0 0 0.09
    rotate [ expr $a6 ] 0 0 1
    object Arm6 {
	color 10 10 10
	box 0.01 0.0 0 -0.06 0.08 0.06
	cylinder 0.03 -0.04 0.03 y 0.06 0.08
	translate 0 0 0.05
	color 100 100 10
	box 0 -0.03 0 0.01 0.01 0.06
	box 0  0.03 0 0.01 0.01 0.06
    }
     # repere 
    armRepereCond 0.2 0 0 0.05 230 0 0
    popMatrix
}

# Bras en place sur le robot
global armPosX armPosY armPosZ armPosTheta
set armPosX 0.45
set armPosY 0
set armPosZ .815
set armPosTheta 0

proc arm {q1 q2 q3 q4 q5 q6} {
    global armPosX armPosY armPosZ armPosTheta armFrames
    pushMatrix
    translate $armPosX $armPosY $armPosZ
    rotate $armPosTheta 0 0 1
    arm1 $q1 $q2 $q3 $q4 $q5 $q6
    popMatrix
}

#----------------------------------------------------------------------
##
## fenetre de controle du bras
##
proc armControls {} {
    toplevel .bras 
    wm title .bras "bras"
    wm geometry .bras -0+500
    # axes
    scale  .bras.a1  -length 200  -label {Axe 1} -from -240 -to 30 \
	-resolution 0.1 -command {setBras a0 } -orient horizontal
    scale  .bras.a2  -length 200  -label {Axe 2} -from -30 -to 240 \
	-resolution 0.1 -command {setBras a1 } -orient horizontal
    scale  .bras.a3  -length 200  -label {Axe 3} -from -60 -to 210 \
	-resolution 0.1 -command {setBras a2 } -orient horizontal
    scale  .bras.a4  -length 200  -label {Axe 4} -from -150 -to 120 \
	-resolution 0.1 -command {setBras a3 } -orient horizontal
    scale  .bras.a5  -length 200  -label {Axe 5} -from -85 -to 85 \
	-resolution 0.1 -command {setBras a4 } -orient horizontal
    scale  .bras.a6  -length 200  -label {Axe 6} -from -120 -to 150 \
	-resolution 0.1 -command {setBras a5 } -orient horizontal
    pack .bras.a6 -fill x
    pack .bras.a5 -fill x
    pack .bras.a4 -fill x
    pack .bras.a3 -fill x
    pack .bras.a2 -fill x
    pack .bras.a1 -fill x
}

#----------------------------------------------------------------------

##
## setBras - modifie la position du bras d'un robot
##
proc setBras {axis value} {
    global platform 
    
    set platform(r1) {arm [.bras.a1 get] \
			  [.bras.a2 get] \
			  [.bras.a3 get] \
			  [.bras.a4 get] \
			  [.bras.a5 get] \
			  [.bras.a6 get]}
    redrawAllWindows
}

proc gt6a {robot q1 q2 q3 q4 q5 q6} {
    global platform

   #  puts "gt6a $q1 $q2 $q3 $q4 $q5 $q6"
    set platform($robot) [list arm $q1 $q2 $q3 $q4 $q5 $q6 ]
}

proc myRepere { x0 y0 z0 x1 y1 z1 x2 y2 z2 x3 y3 z3 } {
    color 0 100 0
    polyline 2 $x0 $y0 $z0 $x1 $y1 $z1
    color 100 0 0
    polyline 2 $x0 $y0 $z0 $x2 $y2 $z2
    color 0 0 200
    polyline 2 $x0 $y0 $z0 $x3 $y3 $z3
}

proc rep {args} {
    global robots pos

    set robots(repere) [concat myRepere $args ]
    set pos(repere) { 0 0 0 }
}
    
proc beauRepere {x y z l} {
    global armPosX armPosY armPosZ armPosTheta

    pushMatrix
    translate $armPosX $armPosY $armPosZ
    rotate $armPosTheta 0 0 1

    translate $x $y $z
    color 255 0 0
    repere $l
    popMatrix
}
